This repository contains code for a Kubernetes `SylvaWorkloadCluster` CRD and operator that provides a declarative API for defining and managing the desired state of Sylva workload clusters and ensuring that the actual state of the clusters matches the desired state.
Users define workload clusters through YAML files, specifying configuration details such as k8s version, desired infrastructure platform, machine details or enabled units.The operator handles the creation, update, scaling, and deletion of clusters, abstracting away the complexity involved in managing workload clusters, making it more accessible to users without deep Kubernetes expertise.
This operator uses another CRD, [`SylvaUnitsRelease`](https://gitlab.com/sylva-projects/sylva-elements/sylva-units-operator/-/tree/main) to manage the creation of a FluxCD HelmRelease for the [`sylva-units`](https://gitlab.com/sylva-projects/sylva-core/-/tree/main/charts/sylva-units?ref_type=heads) Helm chart, which encapsulates the desired state and configuration of Sylva workload clusters.
